<!DOCTYPE html>

<!-- BEGIN html -->
<html <?php language_attributes(); ?>>
<!-- A ThemeZilla design (http://www.themezilla.com) - Proudly powered by WordPress (http://wordpress.org) -->

<!-- BEGIN head -->
<head>

	<!-- Meta Tags -->
	<meta http-equiv="Content-Type" content="<?php bloginfo('html_type'); ?>; charset=<?php bloginfo('charset'); ?>" />
	
	<!-- Title -->
	<title><?php wp_title('|', true, 'right'); ?><?php bloginfo('name'); ?></title>
	
	<!-- Stylesheets -->
	<link rel="stylesheet" href="<?php bloginfo('stylesheet_url'); ?>" type="text/css" media="screen" />
	<link rel="stylesheet" href="<?php echo get_template_directory_uri(); ?>/css/<?php echo get_option('tz_alt_stylesheet'); ?>" type="text/css" media="screen" />
	<?php wp_enqueue_style( array( 'child-dark' ) ); ?>
	
	<!-- RSS & Pingbacks -->
	<link rel="alternate" type="application/rss+xml" title="<?php bloginfo( 'name' ); ?> RSS Feed" href="<?php if (get_option('tz_feedburner')) { echo get_option('tz_feedburner'); } else { bloginfo( 'rss2_url' ); } ?>" />
	<link rel="pingback" href="<?php bloginfo( 'pingback_url' ); ?>" />

	<?php wp_head(); ?>

<script type="text/javascript">

  var _gaq = _gaq || [];
  _gaq.push(['_setAccount', 'UA-40051687-1']);
  _gaq.push(['_trackPageview']);

  (function() {
    var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
    ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
    var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
  })();

</script>
<!-- END head -->
</head>

<!-- BEGIN body -->
<body <?php body_class(); ?>>

	<!-- BEGIN #container -->
	<div id="container">
	
		<!-- BEGIN #header -->
		<div id="header">

            <!-- BEGIN #header-top --> 
            <div id="header-top">
            
                <!-- BEGIN .header-inner -->
                <div class="header-inner clearfix">
                
                    <!-- BEGIN #logo -->
                    <div id="logo">
                        <?php /*
                        If "plain text logo" is set in theme options then use text
                        if a logo url has been set in theme options then use that
                        if none of the above then use the default logo.png */
                        if (get_option('tz_plain_logo') == 'true') { ?>
                        <a href="<?php echo home_url(); ?>"><?php bloginfo( 'name' ); ?></a>
                        <?php } elseif (get_option('tz_logo')) { ?>
                        <a href="<?php echo home_url(); ?>"><img src="<?php echo get_option('tz_logo'); ?>" alt="<?php bloginfo( 'name' ); ?>"/></a>
                        <?php } else { ?>
                        
                        <?php if(get_option('tz_alt_stylesheet') == 'light.css') : ?>
                        <a href="<?php echo home_url(); ?>"><img src="<?php echo get_template_directory_uri(); ?>/images/light/logo.png" alt="<?php bloginfo( 'name' ); ?>" /></a>
                        <?php else: ?>
                        <a href="<?php echo home_url(); ?>"><img src="<?php echo get_template_directory_uri(); ?>/images/dark/logo.png" alt="<?php bloginfo( 'name' ); ?>" /></a>
                        <?php endif; ?>
                        
                        <?php } ?>
                    <!-- END #logo -->
                    </div>
                    
                    <!-- BEGIN #primary-nav -->
                    <div id="primary-nav">
                        <?php wp_nav_menu( array( 'theme_location' => 'primary-menu' ) ); ?>
                    <!-- END #primary-nav -->
                    </div>
                    
                <!-- END .header-inner -->
                </div>
            
            <!-- END #header-top -->    
            </div>
            
            <?php if(is_page_template('template-home.php')) : ?>
            
            <?php get_template_part('includes/home-slider'); ?>
            
            <?php endif; ?>
			
		<!--END #header-->
		</div>

		<!--BEGIN #content -->
		<div id="content">
        	
            <?php $dots = get_option('tz_slider_dots'); ?>
            
        	<!--BEGIN #content-inner -->
			<div id="content-inner" class="clearfix <?php if($dots == 'true') : ?>dots-enabled<?php endif; ?>">
		
